//"rapkokr.sc","Raport kasowy za okres",12329,0,1.1.0,SYSTEM
//"Pienidze",12002,14,16
/////////////////////////////////
// Raport kasowy za okres
// rapkokr.sc
/////////////////////////////////

#define OK 2
#define ANULUJ -1

int typWydruku = Val( Arg0 )
#include "Zestawienia - ustawienia"

int GRAF = !Val(arg0)
int err,i,pom,nTblWidth,nFootWidth,bGrayTrigger
string sNumer,sDataOd,sDataDo
float fWn,fMa
float fStanPocz
long lTemp

int pn = Open KatalogFirmy() + "51pn.dat" For base "PN"
BaseError ( pn,4 )

string tNameRej(1)
long	 tIdRej(1)
long nCurrRej
long nNumOfRej = 0

int xt=open KatalogFirmy()+"51xt.dat" for base "XT"
BaseError(xt,4)
SetKey(xt,"super")
SetKeySeg(xt,"super",3400)
SetKeySeg(xt,"kod","")
err=GetRec(xt,GE)
while !err && GetField(xt,"super")==3400
	if GetField(xt,"subtypi")==81 then
		if nNumOfRej then grow tNameRej,1 :  grow tIdRej,1
		nNumOfRej+=1
		tIdRej(nNumOfRej) = GetField(xt,"id")
		tNameRej(nNumOfRej)=GetField(xt,"kod")
	endif
	err=GetRec(xt,NX)
wend

if !nNumOfRej then message "Brak rejestrw pieninych" : error ""

sDataOd=GetIni( GetReportName(), "Od daty" )
sDataDo=GetIni( GetReportName(), "Do daty" )
if !sDataOd then sDataOd=Data()
if !sDataDo then sDataDo=Data()

buf = data()
find regular ":d:d{:d:d}/-:d:d/-:d:d"
string sRok = (regular 1)

if ( buf = GetIni ( GetReportName(),"Numer" ) ) then
	if find regular "RK {:d##}//:d:d" then
		sNumer = using "RK %d/%s",val(regular 1)+1,sRok
	else
		sNumer = buf
	endif
else
	sNumer = "RK 1/"+sRok
endif


int sub Ustawienia()
	Ustawienia = 0
	DialogUstawien()	
endsub


int sub CheckFields()
	CheckFields = OK
	save
	buf = sDataOd
	if !(find regular "^(:d:d)|():d:d/-:d:d/-:d:d$") then CheckFields = 0
	buf = sDataDo
	if !(find regular "^(:d:d)|():d:d/-(:d)|():d/-(:d)|():d$") then CheckFields = 0
	if !CheckFields	then message "Niepoprawny format daty. Uyj formatu RRRR-MM-DD" : exit
	if sDataOd>sDataDo then message "Data w polu 'Od daty' powinna by wczeniejsza od daty w polu 'Do daty'" : CheckFields=0
endsub

nCurrRej = Val(GetIni ( GetReportName(),"Rejestr" ) )
if nCurrRej<1 || nCurrRej>nNumOfRej then nCurrRej=1

LoadDefFromIni()
ConvValues()

Form GetReportName(),340,150
	text "Numer",10,16,35,20
	Edit "",sNumer,50,12,110,18
	text "Rejestr",10,47,35,20
	cmbbox "",tNameRej, nCurrRej, 50,43,110,150
	Group "",175,00,150,70
		DatEdit "Od daty",sDataOd,230,18,80,18
		DatEdit "Do daty",sDataDo,230,42,80,18
	Button "&OK",175,95,70,25,CheckFields()
	Button "&Anuluj",255,95,70,25,ANULUJ
	Button "&Ustawienia wydruku...",10,75,130,24,Ustawienia()
if ExecForm==ANULUJ then Error ""

PutIni ( GetReportName(),"Rejestr", using "%d",nCurrRej )
PutIni ( GetReportName(),"Numer",sNumer )
PutIni ( GetReportName(),"Od daty",sDataOd )
PutIni ( GetReportName(),"Do daty",sDataDo )

nCurrRej = tIdRej(nCurrRej)

// znalezienie wartoci pocztkowej
SetKey ( pn,"khid" )
SetKeySeg( pn, "khid", nCurrRej )
SetKeySeg( pn, "typi", 1 )
SetKeySeg( pn, "termin", sDataOd )
err=GetRec(pn,GE)
pom=0
while !err && GetField(pn,"khid")==nCurrRej && GetField(pn,"typi")==1
	if GetField(pn,"flag")&16384 then fStanPocz=GetField(pn,"stan") : pom=1 : exit
	err=GetRec(pn,NX)
wend
if !pom then
	SetKeySeg( pn, "khid", nCurrRej )
	SetKeySeg( pn, "typi", 1 )
	SetKeySeg( pn, "termin", sDataOd )
	err=GetRec(pn,LT)
	pom=0
	while !err && GetField(pn,"khid")==nCurrRej && GetField(pn,"typi")==1
		if GetField(pn,"flag")&16384 then fStanPocz=GetField(pn,"stan")+GetField(pn,"kwota")+GetField(pn,"kwotarozl") : pom=1 : exit
		err=GetRec(pn,PR)
	wend
endif

string nazwaRaportu = "Raport kasowy za okres od "+sDataOd+" do "+sDataDo+lf+"Nr raportu kasowego "+sNumer
#include "Nagwek i stopka raportu"
NoDate=1
int nc,tl,tc,tr,lp

if GRAF then
	str.wydruk ( 0,-1,nOrient-1 )
	strona 50,300,50,100
	nc = Styl ( "nagwek",0 )
	tl = Styl ( "tekst",-1 )
	tc = Styl ( "tekst",0 )
	tr = Styl ( "tekst",1 )
else
	str.wydruk ( 1,-1,nOrient-1 )
	strona 50,300,50,100
	nc = Styl ( "10cpi",0 )
	tl = Styl ( "17cpi",-1 )
	tc = Styl ( "17cpi",0 )
	tr = Styl ( "17cpi",1 )
endif

int KolTab1(8) = 80,240,200,490,180,180,220,290
int KolTabP(3)
int StlTabH(8) = nc,nc,nc,nc,nc,nc,nc,nc
int StlTab1(8) = tr,tc,tr,tl,tr,tr,tr,tl
int StlTabP(3) = tl,tr,tr

KolTab1(3)=nDataWt
KolTab1(5)=KolTab1(6) = nKwotaWt

for i=1 to i>size(KolTab1)
	nTblWidth+=KolTab1(i)
next i

for i=1 to i>size(KolTab1)
	lTemp = KolTab1(i)
	lTemp= lTemp*(str.szer)
	lTemp=lTemp/nTblWidth
	KolTab1(i)=lTemp
next i
nTblWidth = str.szer

KolTabP(1)=KolTab1(4)
KolTabP(2)=KolTab1(5)
KolTabP(3)=KolTab1(6)
nFootWidth = KolTabP(1) + KolTabP(2) + KolTabP(3)

int tblH = tabela nSzerHead,1000*nHeadY+nHeadX,KolTab1,StlTabH
int tbl1 = tabela nSzerMain*(!bVertLines),1000*nMainY+nMainX,KolTab1,Stltab1
int tblP = tabela nSzerFoot,1000*nFootY+nFootX,KolTabP,StlTabP

Header(1)

Ramka od 0,#Y+10*GRAF,str.szer,10,0,nGreyHead
	tabela #tblH
		kolumna 1,"Lp."
		kolumna 2,"Nr. dokumentu"
		kolumna 3,"Data"
		kolumna 4,"Opis"
		kolumna 5,"Wn"
		kolumna 6,"Ma"
		kolumna 7: SetStyl(tc) : print "Konto"+lf+"przeciwstawne"
		kolumna 8,"Kontrahent"
	koniec
koniec


//zmieniono klucz z data na rejestr
// nierozliczone dokumenty kasowe nie zachowuja swoja pozycje w raporcie

setkey(pn,"rejestr")
setkeyseg(pn,"rejestr", val(using "%d", nCurrRej))
SetKeySeg(pn,"termin",sDataOd)
setkeyseg(pn,"id",0)
setkeyseg(pn,"typi",3)

err = GetRec( pn,GE)

	while !err && GetField(pn,"termin")<=sDataDo
		
		if (getfield(pn,"typi")>=2 && getfield(pn,"typi")<=3) && GetField(pn,"rejestr")==nCurrRej then
			ramka nTblWidth,10,0,bGrayTrigger*nGreyMain
				tabela #tbl1
					kolumna 1,using "%d",(lp+=1)
					kolumna 2,GetField ( pn,"kod" )
					kolumna 3,GetField ( pn,"termin" )
					kolumna 4,GetField(pn,"opis")
					if GetField( pn,"wyplatai" ) then
						fMa -= GetField ( pn,"kwota" )
						kolumna 5,"0,00"
						kolumna 6,kwota ( -GetField ( pn,"kwota" ) )
					else
						fWn += GetField ( pn,"kwota" )
						kolumna 5,kwota ( GetField ( pn,"kwota" ) )
						kolumna 6,"0,00"
					endif
					kolumna 8,GetField ( pn,"khkod" )
				koniec
			koniec
			if bVertLines then
				pom=0
				for i=1 to i>size(KolTab1)
					pom+=KolTab1(i)
					DrawLine at pom,str.pozycja(#T),0,str.pozycja(#B)-str.pozycja(#T),nSzerMain
				next i
				DrawLine at 0,str.pozycja(#T),0,str.pozycja(#B)-str.pozycja(#T),nSzerMain
			endif
			if bOddGrey then bGrayTrigger=!bGrayTrigger
		endif
		err=GetRec(pn,NX)
	wend


if bVertLines then DrawLine at 0,#Y,nTblWidth,0,nSzerMain

i=KolTab1(1)+KolTab1(2)+KolTab1(3)
if !GRAF then rysuj"-" : print LF
ramka od i,#Y+20*GRAF,nFootWidth,20,0,nGreyFoot
	tabela #tblP
		kolumna 1,"Obroty"
		kolumna 2,kwota ( fWn )
		kolumna 3,kwota ( fMa )
	koniec
	tabela #tblP
		kolumna 1,"Z poprzedniego raportu"
		if Sign(fStanPocz)>=0 then
			kolumna 2,kwota( fStanPocz )
		else
			kolumna 3,kwota( -fStanPocz )
		endif
	koniec
	fStanPocz = fStanPocz+fWn-fMa
	tabela #tblP
		kolumna 1,"Stan kasy"
		if Sign(fStanPocz)>=0 then
			kolumna 2,kwota( fStanPocz )
		else
			kolumna 3,kwota( -fStanPocz )
		endif
	koniec
koniec
close
Footer(1)